/*
 *	Title:		o3find
 *	Version:	0.70
 *	Created by:	Paolo Copello
 *	Home page:	http://web.tiscali.it/fanelia
 *	
 *	Copyright (C) 2003 Paolo Copello
 *	
 *	******************************************
 *	This file is part of o3find
 *	******************************************
 *	
 *	o3find is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	any later version.
 *	
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *	
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *	
 */


#ifndef __FANEL_FILEFIND_37877C00_92FF_403c_8253_B5CBB59E93F0_INCLUDED
#define __FANEL_FILEFIND_37877C00_92FF_403c_8253_B5CBB59E93F0_INCLUDED




#include "config.h"

namespace Fanel
{

class FileFinder
{
public:
	FileFinder();

	bool Find(const list<string>& directoryList, const list<string>& sFilterList, list<string>& lst, bool bSubDir = false);
	bool Find(const string& sDirectory, const list<string>& sFilterList, list<string>& lst, bool bSubDir = false);
	bool Find(const string& sDirectory, const string& sFilter, list<string>& lst, bool bSubDir = false);

	void Stop();

private:
	void AppendSlashToDir(string& sDirectory);
	void FindDirectoriesInDir(const string& sDirectory, list<string>& lst);
	void FindFilesSingleDir(const string& sDirectory, const list<string>& sFilterList, list<string>& lst);
	void FindFilesSingleDirOneFilter(const string& sDirectory, const string& sFilter, list<string>& lst); //, bool bCheckUnique = false);

	bool RecursiveFind(const string& sDirectory, const list<string>& sFilterList, list<string>& lst, bool bSubDir);

#ifdef FANEL_MULTITHREAD_SUPPORT
	volatile
#endif
	bool _bRunning;

};

} // end namespace Fanel


#endif // __FANEL_FILEFIND_37877C00_92FF_403c_8253_B5CBB59E93F0_INCLUDED

